﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Net;

namespace TinyDownloader
{
    public class DownloadItem
    {
        public string FolderPath { get; set; }
        public string FileName { get; set; }
        public string Url { get; set; }
    }

    class Program
    {
        private const string downloadFilePath = "E:\\Private\\csharpExample\\TinyDownloader\\bin\\Debug\\net5.0\\DownloadList.json";

        private static List<DownloadItem> GetDownloadItems(string path)
        {
            List<DownloadItem> downloadList = File.Exists(path)
                ? JsonConvert.DeserializeObject<List<DownloadItem>>(File.ReadAllText(path))
                : null;

            return downloadList;
        }

        static void Main(string[] args)
        {
            List<DownloadItem> items = GetDownloadItems(downloadFilePath);

            foreach(var item in items)
            {
                Console.WriteLine("############################################################################");
                HttpWebRequest request = (HttpWebRequest)WebRequest.Create(item.Url);
                request.Method = "GET";
                request.AddRange(0, 0);  //first byte request header.

                using (WebResponse resp = request.GetResponse())
                {
                    var buff = new byte[1024];
                    int pos = 0;
                    int count;

                    WebHeaderCollection header = resp.Headers;

                    foreach(string key in header.AllKeys)
                    {
                        Console.WriteLine($"{key} : value {header[key]}");
                    }

                    using (Stream stream = resp.GetResponseStream())
                    {
                        using (var fs = new FileStream(Path.Combine(item.FolderPath, item.FileName), FileMode.Create))
                        {
                            do
                            {
                                count = stream.Read(buff, pos, buff.Length);
                                fs.Write(buff, 0, count);
                            } while (count > 0);
                        }
                    }
                }
            }
            

            Console.WriteLine("Hello World!");
        }
    }
}
